Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_output_mod.F90	(revision 2866)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_output_mod.F90	(revision 2907)
@@ -46,5 +46,5 @@
     USE mod_grid_phy_lmdz, only: klon_glo,nbp_lon,nbp_lat
     USE print_control_mod, ONLY: prt_level,lunout
-    USE vertical_layers_mod, ONLY: ap,bp,preff,presnivs
+    USE vertical_layers_mod, ONLY: ap,bp,preff,presnivs, Ahyb, Bhyb
     USE time_phylmdz_mod, ONLY: day_ini, itau_phy, start_time, annee_ref, day_ref
 #ifdef CPP_XIOS
@@ -95,5 +95,5 @@
     INTEGER                               :: idayref
     REAL                                  :: zjulian_start, zjulian
-    REAL, DIMENSION(klev)                 :: Ahyb, Bhyb, Alt
+    REAL, DIMENSION(klev)                 :: Alt
     CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
     REAL, DIMENSION(nlevSTD)              :: rlevSTD
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/physiq_mod.F90	(revision 2866)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/physiq_mod.F90	(revision 2907)
@@ -223,5 +223,5 @@
     use FLOTT_GWD_rando_m, only: FLOTT_GWD_rando
     use ACAMA_GWD_rando_m, only: ACAMA_GWD_rando
-
+    USE vertical_layers_mod, only : Ahyb, Bhyb
     IMPLICIT none
     !>======================================================================
@@ -1076,4 +1076,5 @@
     INTEGER :: nbtr_tmp ! Number of tracer inside concvl
     REAL, dimension(klon,klev) :: sh_in ! Specific humidity entering in phytrac
+    REAL, dimension(klon,klev) :: ch_in ! Condensed humidity entering in phytrac (eau liquide)
     integer iostat
 
@@ -1584,4 +1585,5 @@
                start_time, &
                itau_phy, &
+               date0, &
                io_lon, &
                io_lat)
@@ -3754,5 +3756,5 @@
                (kdlon,kflev,dist, rmu0, fract, solaire, &
                paprs, pplay,zxtsol,albsol1, albsol2, t_seri,q_seri, &
-               wo(:, :, 1), &
+               size(wo,3), wo(:, :, 1), &
                cldfrarad, cldemirad, cldtaurad, &
                heat,heat0,cool,cool0,albpla, &
@@ -4262,4 +4264,5 @@
     ELSE
        sh_in(:,:) = qx(:,:,ivap)
+       ch_in(:,:) = qx(:,:,iliq)
     END IF
 
@@ -4276,5 +4279,5 @@
          frac_impa,frac_nucl, beta_prec_fisrt,beta_prec, &
          presnivs, pphis,     pphi,     albsol1, &
-         sh_in,    rhcl,      cldfra,   rneb, &
+         sh_in,    ch_in,  rhcl,      cldfra,   rneb, &
          diafra,   cldliq,    itop_con, ibas_con, &
          pmflxr,   pmflxs,    prfl,     psfl, &
@@ -4413,5 +4416,6 @@
             pphi, &
             pphis, &
-            zx_rh)
+            zx_rh, &
+            Ahyb, Bhyb)
 
        CALL VTe(VTinca)
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phytrac_mod.F90	(revision 2866)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phytrac_mod.F90	(revision 2907)
@@ -66,5 +66,5 @@
        frac_impa,frac_nucl,beta_fisrt,beta_v1,        &
        presnivs,  pphis,    pphi,     albsol,         &
-       sh,        rh,       cldfra,   rneb,           &
+       sh,        ch, rh,       cldfra,   rneb,           &
        diafra,    cldliq,   itop_con, ibas_con,       &
        pmflxr,    pmflxs,   prfl,     psfl,           &
@@ -131,4 +131,5 @@
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: rh      ! humidite relative
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: ch      ! eau liquide
     REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
@@ -575,5 +576,5 @@
             pdtphys,  t_seri,   paprs,          pplay,     &
             pmfu,     upwd,     ftsol,  pctsrf, pphis,     &
-            pphi,     albsol,   sh,             rh,        &
+            pphi,     albsol,   sh,             ch, rh,        &
             cldfra,   rneb,     diafra,         cldliq,    &
             itop_con, ibas_con, pmflxr,         pmflxs,    &
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/tracinca_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/tracinca_mod.F90	(revision 2866)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/tracinca_mod.F90	(revision 2907)
@@ -36,5 +36,5 @@
        pdtphys,  t_seri,   paprs,          pplay,     &
        pmfu,     upwd,     ftsol,  pctsrf, pphis,     &
-       pphi,     albsol,   sh,             rh,        &
+       pphi,     albsol,   sh,             ch, rh,    &
        cldfra,   rneb,     diafra,         cldliq,    &
        itop_con, ibas_con, pmflxr,         pmflxs,    &
@@ -76,4 +76,5 @@
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: ch      ! eau liquide
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: rh      ! humidite relative
     REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
@@ -185,4 +186,5 @@
          t_seri,     & !tfld
          sh,         & !sh
+         ch,         & !ql
          rh,         & !rh
          nbp_lon,    & !nx
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/vertical_layers_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/vertical_layers_mod.F90	(revision 2866)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/vertical_layers_mod.F90	(revision 2907)
@@ -15,5 +15,6 @@
    
 !$OMP THREADPRIVATE(preff,scaleheight,ap,bp,presnivs,pseudoalt)
-
+   REAL, SAVE, ALLOCATABLE :: Ahyb(:), Bhyb(:)
+!$OMP THREADPRIVATE(Ahyb, Bhyb) 
 
 CONTAINS
@@ -34,5 +35,8 @@
     ALLOCATE(presnivs(nlayer))
     ALLOCATE(pseudoalt(nlayer))
-  
+    ALLOCATE(Ahyb(nlayer)) 
+    ALLOCATE(Bhyb(nlayer)) 
+
+
     preff = preff_
     scaleheight=scaleheight_