Index: LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/surf_land_orchidee_nofrein_mod.F90
===================================================================
--- LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/surf_land_orchidee_mod.F90	(revision 2927)
+++ LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/surf_land_orchidee_nofrein_mod.F90	(revision 2934)
@@ -1,14 +1,13 @@
 !
 MODULE surf_land_orchidee_mod
-#ifndef ORCHIDEE_NOOPENMP
-#ifndef ORCHIDEE_NOZ0H
-#ifndef ORCHIDEE_NOFREIN
-!FC la derniere ligne et la fin
+#ifdef ORCHIDEE_NOFREIN
 !
 ! This module controles the interface towards the model ORCHIDEE.
 !
 ! Compatibility with ORCHIDIEE :
-! The current version can be used with ORCHIDEE/trunk from revision 3525.
-! This interface is used if none of the cpp keys ORCHIDEE_NOOPENMP or ORCHIDEE_NOZ0H is set.
+! This module is compiled only if cpp key ORCHIDEE_NOFREIN is defined. 
+! The current version can be used with ORCHIDEE/trunk from revision 3525-4465 
+! (it can be used for later revisions also but it is not needed.)
+! 
 !
 ! Subroutines in this module : surf_land_orchidee
@@ -47,5 +46,4 @@
        emis_new, z0m_new, z0h_new, qsurf, &
        veget, lai, height )
-!FC
 
 
@@ -113,5 +111,4 @@
 !
     INCLUDE "YOMCST.h"
-!FC
     INCLUDE "dimpft.h"
 
@@ -147,8 +144,7 @@
     REAL, DIMENSION(klon), INTENT(OUT)        :: alb1_new, alb2_new
     REAL, DIMENSION(klon), INTENT(OUT)        :: emis_new, z0m_new, z0h_new
-!FC
-    REAL, DIMENSION (klon,nvm_lmdz),INTENT(OUT)         :: veget
-    REAL, DIMENSION (klon,nvm_lmdz),INTENT(OUT)         :: lai
-    REAL, DIMENSION (klon,nvm_lmdz) ,INTENT(OUT)        :: height
+    REAL, DIMENSION(klon,nvm_lmdz), INTENT(OUT) :: veget ! dummy variables
+    REAL, DIMENSION(klon,nvm_lmdz), INTENT(OUT) :: lai   ! dummy variables
+    REAL, DIMENSION(klon,nvm_lmdz), INTENT(OUT) :: height! dummy variables
 
 
@@ -225,4 +221,9 @@
     IF (check) WRITE(lunout,*)'Entree ', modname
   
+    IF (ifl_pbltree == 1) THEN
+       abort_message='Pb de coherence: cette interface vers ORCHIDEE ne peut pas etre utilise avec ifl_pbltree'
+       CALL abort_physic(modname,abort_message,1)
+    END IF
+
 ! Initialisation
   
@@ -230,7 +231,4 @@
 ! Test of coherence between variable ok_veget and cpp key CPP_VEGET
 #ifndef CPP_VEGET
-             print* , "nvm_orch FC  ", nvm_orch
-             print* , "nvm_lmdz FC  ", nvm_lmdz
-
        abort_message='Pb de coherence: ok_veget = .true. mais CPP_VEGET = .false.'
        CALL abort_physic(modname,abort_message,1)
@@ -426,6 +424,6 @@
                precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
                evap, fluxsens, fluxlat, coastalflow, riverflow, &
-               tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0m_new, &    
-               lon_scat, lat_scat, q2m, t2m, z0h_new, nvm_orch)
+               tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0m_new, &
+               lon_scat, lat_scat, q2m, t2m, z0h_new)
 #endif         
        ENDIF
@@ -443,11 +441,4 @@
     IF (knon > 0) THEN
 #ifdef CPP_VEGET    
-!FC
-           if(nvm_orch .ne.nvm_lmdz ) then
-       abort_message='Pb de dimensiosn PFT: nvm_orch et nvm_lmdz differents.'
-       CALL abort_physic(modname,abort_message,1)
-           endif
-!FC
-
        CALL intersurf_main_gathered (itime+itau_phy, nbp_lon, nbp_lat, knon, ktindex, dtime,  &
             lrestart_read, lrestart_write, lalo, &
@@ -458,9 +449,6 @@
             evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
             tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0m_new(1:knon), &
-            lon_scat, lat_scat, q2m, t2m, z0h_new(1:knon),&
-            veget(1:knon,:),lai(1:knon,:),height(1:knon,:),&
-              coszang=yrmu0(1:knon))
+            lon_scat, lat_scat, q2m, t2m, z0h_new(1:knon), coszang=yrmu0(1:knon))
 #endif       
-!FC on doit mettre nvm_orch la ???
     ENDIF
 
@@ -691,4 +679,3 @@
 #endif
 #endif
-#endif
 END MODULE surf_land_orchidee_mod